﻿namespace UltraGridIssue
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win.FormattedLinkLabel;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            this.uiElementViewerDialog1.Show();
            this.Load += Form1_Load;
            this.ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            this.ultraGrid1.BeforeCellActivate += UltraGrid1_BeforeCellActivate;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var data = this.GetData(3, 2);
            this.ultraGrid1.SetDataBinding(data, data.TableName);
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Override.CellClickAction = CellClickAction.RowSelect;
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.FormattedText;

            //  If you need to handle LinkClicked event of the FormattedLinkEditor
            //  set the ActiveCellAppearance to be same as SelectedRowAppearance
            //  and handle LinkClicked event
            ((FormattedLinkEditor)e.Layout.Bands[0].Columns[0].Editor).LinkClicked += OnLinkClicked;
            e.Layout.Override.ActiveCellAppearance = e.Layout.Override.SelectedRowAppearance;
        }

        private void OnLinkClicked(object sender, Infragistics.Win.FormattedLinkLabel.LinkClickedEventArgs e)
        {
            // TODO: handle clicked link event, e.g. open the link in a browser.
        }

        private void UltraGrid1_BeforeCellActivate(object sender, Infragistics.Win.UltraWinGrid.CancelableCellEventArgs e)
        {
            //  If you do not need to handle LinkClicked event you can directly
            //  cancel BeforeCellActivate event
            if(e.Cell.EditorResolved is FormattedLinkEditor)
                e.Cancel = true;
        }

        private DataTable GetData(int rows = 20, int cols = 5)
        {
            DataTable dt = new DataTable();

            for(int col = 0; col < cols; col++)
            {
                dt.Columns.Add(string.Format("Column #{0}", col + 1));
            }

            for(int row = 0; row < rows; row++)
            {
                DataRow addRow = dt.NewRow();
                foreach(DataColumn column in dt.Columns)
                {
                    if(column.Ordinal == 0)
                    {
                        addRow[column] = "<a><font color=\"black\">Text text</font></a>";
                    }
                    else
                    {
                        addRow[column] = "Not link";
                    }
                }

                dt.Rows.Add(addRow);
            }

            return dt;
        }
    }
}
